var AlmacenajeTemporal = function () {
  this.almacen = undefined;
  this.disponible = !!window.localStorage;
  this.guardar_local = guardar_local;
  this.items_almacenados = window.localStorage.length;
  this.mostrar_items_almacenados = mostrar_items_almacenados;
  this.sincronizar = sincronizar;
  
  if (!this.disponible) {
    alert('La aplicación no va a guardar tus resultados');
  } else {
    this.almacen = window.localStorage;
  }
  
  function guardar_local(valor) {
    this.items_almacenados++;
    this.almacen.setItem(this.items_almacenados, valor);
  }
  
  function mostrar_items_almacenados() {
    var tmp_items = [];
    if (this.almacen !== undefined) {
      for (var i = 0; i < this.almacen.length; i++) {
         var tmp_key = this.almacen.key(i);
         tmp_items.push(this.almacen.getItem(tmp_key));
       }
     } 
     return tmp_items;   
  }
  
  function sincronizar() {
    var params = "";

    if (this.almacen !== undefined && this.almacen.length > 0) {
      var max = this.almacen.length;
      for (i = 0; i < max; i++) {
        var tmp_key = this.almacen.key(i);
        params += "&item[]=" + encodeURIComponent(this.almacen.getItem(tmp_key));  
       }       
       // IE9+
       var xhr = new XMLHttpRequest();
       xhr.open('POST', 'sync.php', true);
       xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=utf-8');
       xhr.send(params); 
       this.almacen.clear();
     } 
  }
};

var GUI = function (opciones) {
  this.status = ''; 
  this.status_bar = document.getElementById('app-status'); 
  this.online = online;
  this.offline = offline;  
  this.warning = warning;
  this.form = document.getElementById('app-form');
  this.item = document.getElementById('item');
  this.validar = validar;
  this.revisar_estado = revisar_estado;
  this.form.addEventListener('submit', validar, false);
 
  function online() {
    this.status = 1;
    this.status_bar.innerHTML = "En línea";
    this.status_bar.className = 'online-status';   
    opciones.almacen.sincronizar();  
  }
  
  function offline() {
    this.status = 0;   
    this.status_bar.innerHTML = "Desconectado";   
    this.status_bar.className = 'offline-status';        
  } 
  
  function warning() {
    this.status = 0;   
    this.status_bar.innerHTML = "¡Advertencia!";   
    this.status_bar.className = 'warning-status';    
  }

  function revisar_estado(instancia) {
    if (navigator.onLine) {
      instancia.online();
    }  else {
      instancia.offline();    
    } 
  }  

  setInterval(revisar_estado, 2000, this);
};

function validar(e) {
  if (app.status == 1) {
      if (app.form.item.value === "") {
        e.preventDefault();      
        app.item.style.border = "1px solid red";     
        return false;
      } else {
        return true;
      }      
  } else {

      e.preventDefault();
    if (this.item.value === "") { 
      app.item.style.border = "1px solid red";     
      return false;
    } else {
      almacenaje.guardar_local(item.value);
      app.item.style.border = "1px solid green";
      app.item.value = "";
      return true;
    }
  }
}

var almacenaje = new AlmacenajeTemporal();
var parametros = {almacen: almacenaje};
var app = new GUI(parametros);